jQuery(document).ready(function($){

	// Hide and show the Shortcode builder panel

	$('.' + nnr_q_shortcode.prefix + 'shortcode-builder').click(function(e){
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-box').show();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').show();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').addClass('fade in');
		e.preventDefault();
	});

	$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-close').click(function(e){
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		e.preventDefault();
	});

	// Hide and show shortcode settings

	$('.' + nnr_q_shortcode.prefix + 'platform').hide();
	$('.' + nnr_q_shortcode.prefix + 'platform-' + $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val()).show();

	$('input[name="' + nnr_q_shortcode.prefix + 'platform"]').change(function(){
		$('.' + nnr_q_shortcode.prefix + 'platform').hide();
		$('.' + nnr_q_shortcode.prefix + 'platform-' + $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val()).show();
	});

	$('#' + nnr_q_shortcode.prefix + 'layout').change(function(){

		$('.' + nnr_q_shortcode.prefix + 'style').hide();

		if ( $(this).val() != 'indented' ) {
			$('.' + nnr_q_shortcode.prefix + 'style').show();
		}

	});

	$('.' + nnr_q_shortcode.prefix + 'style').hide();

	if ( $('#' + nnr_q_shortcode.prefix + 'layout').val() != 'indented' ) {
		$('.' + nnr_q_shortcode.prefix + 'style').show();
	}

	// Add shortcode into post content

	$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-add').click(function(e){
		e.preventDefault();
		wp.media.editor.insert($('.' + nnr_q_shortcode.prefix + 'shortcode').html());
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');

		// Increment the auto counter for the shortcode

		var regex = new RegExp('(' + $('.nnr-q-id').data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var shortcode = $('.nnr-q-shortcode').html();

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex , $('.nnr-q-id').data('shortcode') + '="nnrobots_related_posts_' + response + '"');
		}

		$('.' + nnr_q_shortcode.prefix + 'shortcode').html(shortcode);

	});

	// Save default settings

	$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-default').click(function(e){
		e.preventDefault();

		$(this).append('<img class="alignnone" src="' + nnr_q_shortcode.admin_url + 'images/spinner.gif" width="16" height="16">');

		var data = {
			'action': 'nnr_q_shortcode_default',
			'text': $('#' + nnr_q_shortcode.prefix + 'text').val(),
			'platform': $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val(),
			'layout': $('#' + nnr_q_shortcode.prefix + 'layout').val(),
			'style': $('#' + nnr_q_shortcode.prefix + 'style').val(),
			'button_text': $('#' + nnr_q_shortcode.prefix + 'button-text').val(),
		};

		$.post(nnr_q_shortcode.ajaxurl, data, function(response) {
			$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-default img.alignnone').remove();
		});

	});

	$('body').on('click', function(e){

		if ($('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').is(e.target)) {
			$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-box').hide();
			$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').hide();
			$('.' + nnr_q_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		}
	});

	// Creating the shortcode

	var shortcode = '[nnr_quotables text="" platform="" layout="" style="" button_text=""]';

	$("." + nnr_q_shortcode.prefix + "shortcode-input").each(function(key, value) {

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val();

		if ($(this).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if ($(this).is(':radio')) {
			val = $("." + nnr_q_shortcode.prefix + "shortcode-input:radio").filter(':checked').val();
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex , $(this).data('shortcode') + '="' + val + '"');
		}

		$("." + nnr_q_shortcode.prefix + "shortcode").html(shortcode);

	});

	$("." + nnr_q_shortcode.prefix + "shortcode-input").keyup(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val().replace(/\"/g, "");

		if ( $(this).data('shortcode') == 'text' ) {
			val = val.substring(0, 139);
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_q_shortcode.prefix + "shortcode").html(shortcode);

	}).change(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val().replace(/\"/g, "");

		if ($(this).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if ($(this).is(':radio')) {
			val = $(this).filter(':checked').val();
		}

		if ( $(this).data('shortcode') == 'text' ) {
			val = val.substring(0, 139);
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_q_shortcode.prefix + "shortcode").html(shortcode);

	});

	// Verify length of the text for twitter sharing

	if ( $('#' + nnr_q_shortcode.prefix + 'text').length != 0 ) {

		var length = $('#' + nnr_q_shortcode.prefix + 'text').val().length;

		if ( $('.' + nnr_q_shortcode.prefix + 'character-count').data('bitly') == 'true' ) {
			url_length = 23;
		} else {
			url_length = $('.' + nnr_q_shortcode.prefix + 'character-count').data('url').length + 1;
		}

		$('.' + nnr_q_shortcode.prefix + 'character-count').hide();
		$('.' + nnr_q_shortcode.prefix + 'character-count span').html(length + url_length);

		if ( $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val() == 'twitter' ) {
			$('.' + nnr_q_shortcode.prefix + 'character-count').show();
		}

		$('input[name="' + nnr_q_shortcode.prefix + 'platform"]').change(function(){
			$('.' + nnr_q_shortcode.prefix + 'character-count').hide();

			if ( $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val() == 'twitter' ) {
				$('.' + nnr_q_shortcode.prefix + 'character-count').show();
			}
		});

		$('#' + nnr_q_shortcode.prefix + 'text').keyup(function(){
			if ( $('input[name="' + nnr_q_shortcode.prefix + 'platform"]:checked').val() == 'twitter' ) {
				$('.' + nnr_q_shortcode.prefix + 'character-count span').html($(this).val().length + url_length);

				if ( $(this).val().length + url_length > 139 ) {
					$('.' + nnr_q_shortcode.prefix + 'character-count span').css('color', 'red');
				} else {
					$('.' + nnr_q_shortcode.prefix + 'character-count span').css('color', 'black');
				}
			}
		});

	}
});